#
# Simple script to run elocate on picks from SAC files
#   SAC filenames with picks should be listed on the command line
#   P and S wave arrivals should be stored in "A" and "T0" header variables
#
# Script provided by Mike Brudzinski - brudzimr@muohio.edu
# sac2eloc and elocate are from Computer Programs in Seismology written by Robert Herrmann - http://www.eas.slu.edu/People/RBHerrmann/CPS/CPS33.html
# 

sac2eloc $*
set lat=`awk '{sum+=$c;n++}END{print sum/n}' c=10 elocate.dat`
set lon=`awk '{sum+=$c;n++}END{print sum/n}' c=11 elocate.dat`
set model=7
elocate -LAT $lat -LON $lon -BATCH -M $model
