	program sac2loc
c-----
c	Read names of SAC files from the command line
c	Process each by opening to read the header values,
c	searching for P and S arrival time picks in the A and T0 
c	header values which are set by hitting 'P' and 'S' under ppk
c	
c	The output file is called elocate.dat
c
c	Then the program elocate can be run
c-----
	integer LID
	parameter(LID=4)

	integer NFILEMX
	parameter (NFILEMX=5000)
	character*132 sfile(NFILEMX)

	integer nsfile

	integer NDATA
	parameter(NDATA=200000)
	real datarr(NDATA)

	integer nerr
	integer nzyear, nzjday, nzhour, nzmin, nzsec, nzmsec
	real a, t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, stla, stlo, stel
	character*8 kstnm, kcmpnm

	integer arid
	character*8 kpha
	

c-----
c	read the command line to get the name of the sac files
c-----

	call gcmdln(nsfile,sfile,NFILEMX)
	if(nsfile.eq.0)call usage()
c-----
c	open the output file
c-----
	open(LID,file='elocate.dat',access='sequential',
     1		form='formatted',status='unknown')
	rewind LID
c-----
c	process the input files
c-----
	arid = 0
	do 1000 i=1,nsfile
		call brsac(1,NDATA,sfile(i),datarr,nerr)
		if(nerr.ge.-3)then
			call getkhv('KSTNM   ',kstnm   ,nerr)
c	write(0,*) nerr,sfile(i),kstnm
			call getkhv('KCMPNM  ',kcmpnm  ,nerr)
			call getfhv('STLA    ',stla    ,nerr)
			call getfhv('STLO    ',stlo    ,nerr)
			call getfhv('STEL    ',stel    ,nerr)
			call getfhv('A       ',a       ,nerr)
			call getfhv('T0      ',t0      ,nerr)
			call getfhv('T1      ',t1      ,nerr)
			call getfhv('T2      ',t2      ,nerr)
			call getfhv('T3      ',t3      ,nerr)
			call getfhv('T4      ',t4      ,nerr)
			call getfhv('T5      ',t5      ,nerr)
			call getfhv('T6      ',t6      ,nerr)
			call getfhv('T7      ',t7      ,nerr)
			call getfhv('T8      ',t8      ,nerr)
			call getfhv('T9      ',t9      ,nerr)
			call getnhv('NZYEAR  ',nzyear  ,nerr)
			call getnhv('NZJDAY  ',nzjday  ,nerr)
			call getnhv('NZHOUR  ',nzhour  ,nerr)
			call getnhv('NZMIN   ',nzmin   ,nerr)
			call getnhv('NZSEC   ',nzsec   ,nerr)
			call getnhv('NZMSEC  ',nzmsec  ,nerr)
c-----
c		safety check
c-----		
			if(stel.eq. -12345.)then
				stel =0
			endif
c-----
c	now convert to CSS time NOTE THIS MUST BE CHECKED AGAINST
c	SAC DEFINITIONS OF REFERENCE TIME 
c-----
			call mnthdy(nzyear,nzjday,nzmon,nzday) 
			if(a .gt. -12345.0)then
				arid = arid + 1
				kpha = 'P       '
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,a,stla,stlo,stel,arid)
			endif
			if(t0 .gt. -12345.0)then
				arid = arid + 1
				kpha = 'S       '
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t0,stla,stlo,stel,arid)
			endif
			if(t1 .gt. -12345.0)then
				call getkhv('KT1     ',kpha      ,nerr)
				arid = arid + 1
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t1,stla,stlo,stel,arid)
			endif
			if(t2 .gt. -12345.0)then
				arid = arid + 1
				call getkhv('KT2     ',kpha      ,nerr)
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t2,stla,stlo,stel,arid)
			endif
			if(t3 .gt. -12345.0)then
				arid = arid + 1
				call getkhv('KT3     ',kpha      ,nerr)
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t3,stla,stlo,stel,arid)
			endif
			if(t4 .gt. -12345.0)then
				arid = arid + 1
				call getkhv('KT4     ',kpha      ,nerr)
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t4,stla,stlo,stel,arid)
			endif
			if(t5 .gt. -12345.0)then
				arid = arid + 1
				call getkhv('KT5     ',kpha      ,nerr)
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t5,stla,stlo,stel,arid)
			endif
			if(t6 .gt. -12345.0)then
				arid = arid + 1
				call getkhv('KT6     ',kpha      ,nerr)
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t6,stla,stlo,stel,arid)
			endif
			if(t7 .gt. -12345.0)then
				arid = arid + 1
				call getkhv('KT7     ',kpha      ,nerr)
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t7,stla,stlo,stel,arid)
			endif
			if(t8 .gt. -12345.0)then
				arid = arid + 1
				call getkhv('KT8     ',kpha      ,nerr)
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t8,stla,stlo,stel,arid)
			endif
			if(t9 .gt. -12345.0)then
				arid = arid + 1
				call getkhv('KT9     ',kpha      ,nerr)
				call output(LID,kstnm,nzyear,nzmon,
     1					nzday,nzhour,nzmin,nzsec,nzmsec,
     1					kpha,t9,stla,stlo,stel,arid)
			endif

		endif
 1000	continue
	close (LID)
	end


	subroutine output(LID,kstnm,nzyear,nzmon,nzday,
     1		nzhour,nzmin,nzsec,nzmsec,
     1		kpha,atime,slat,slon,stelv,arid)
	character kstnm*8, kpha*8
	integer LID
	integer nzyear,nzmon,nzday,nzhour,nzmin,nzsec,nzmsec
	real atime
	real slat,slon,stelv

c------
c	output parameters
c-----
        integer*4 asid, arid, mapd
        character*6 sta
        integer*4 ipwt
        real*8 tp
        real*4 xlat,xlon
        character*2 pfm
        character*8 pph
        character*1 pqual
        character*2 pchan
        real*4 elev
        integer*4 ondate, offdat
	real second
c------
c	conversions and defaults
c-----
	sta = kstnm(1:6)
	pchan = 'Z'
	pqual = 'E'
	pph = kpha
	ipwt = 0
	pfm = 'o'
	asid = arid
	xlat = slat
	xlon = slon
	elev = stelv
	ondate = 0000000
	offdat = 9999999
	
	second = nzsec + 0.001*nzmsec
	call htoe(nzyear,nzmon,nzday,nzhour,nzmin,second,tp)
	tp = tp + atime

        write(LID,1)sta, pchan, tp,
     1  arid, pqual,
     2  pph, ipwt, pfm,asid,xlat, xlon,
     3  elev, ondate, offdat
    1   format(a6,1x,a2,1x,f15.3,1x,i8,1x,a1,1x,a8,1x,i2,1x,a2,1x,i8,
     1  1x,f9.4,1x,f9.4,1x,f9.4,1x,i8,1x,i8)

	return
	end


	subroutine gcmdln(nsfile,sfile,NFILEMX)
c-----
c	parse command line arguments
c----
c	nsfile	I	- number of file names
c	sfile	Ch	- array of file names
c	NFILEMX	I	- dimension of file name array
c-----
	integer nsfile
	character*132 sfile(NFILEMX)

	integer mnmarg
	integer i, nmarg
	character*132 name
c-----
c	initialize
c-----
	nsfile = 0
	i = 0
	nmarg = mnmarg()

 1000	continue
		i = i + 1
		if(i.gt.nmarg)go to 2000
		call mgtarg(i,name)
		if(name(1:2).eq.'-h')then
			call usage()
		else if(name(1:2).eq.'-?')then
			call usage()
		else
			nsfile = nsfile + 1
			sfile(nsfile) = name
		endif
	go to 1000
 2000	continue
	return
	end

	subroutine usage()
	integer LER
	parameter (LER=0)
	write(LER,*)'Usage: sac2loc [-h] [-?] sacfiles'
	write(LER,*)
     1	' sacfiles    - names of sacfiles to process',
     2	' This can be done as  sac2loc *.sac under UNIX'
	write(LER,*)
     1	'-?         (default none )  this help message '
	write(LER,*)
     1	'-h         (default none )  this help message '
	stop
	end
	
